#!/usr/bin/perl
############################################################
eval {
   ($0=~ m,(.*)/[^/]+,)   && unshift (@INC, "$1");
   ($0=~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1");
	unshift(@INC, "./scripts");
	do "./config.pl";

 	require "./english.lng";
	require "./admin.lng";
	require "scripts/admin.pl";
	require "scripts/admin_html.pl";
	require "scripts/default_config.pl";
	require "scripts/library.pl";
	require "scripts/database.pl";
        require "scripts/new_database.pl";
	require "scripts/mojoscripts.pl";
	require "scripts/parse_template.pl";
	require "scripts/html.pl";
	require "scripts/templates.pl";
        require "scripts/serverinfo.pl";

	use CGI::Carp qw(fatalsToBrowser);
	use CGI qw(:standard);
#	use strict;
#	use vars qw(%FORM $Cgi);
	&main;
};
if($@){
	print "Content-Type:text/html\n\n";
	print qq| Error including configuration file <br>Reason: $@ |;
#	&main;
	exit;
}
############################################################
sub main{
	$|++;
	$Cgi = new CGI;$Cgi{mojoscripts_created} = 1;
	&ParseForm;
	my($admin_db, $group_db, $message);
	$anonyminit=1;


#	if(require "config.pl"){	&CheckSession if (-f $CONFIG{admin_db});	}
##Check if you have already install the program, if yes, then ask to enter a passowrd
	if($FORM{action} eq "disable"){
		chmod(0000, "install.cgi");
		print "Location:admin.$FORM{script_ext}?action=login&username=admin&password=mojoscripts\n\n";
	}
	elsif($FORM{action} eq "delete"){
		unlink ("install.$FORM{script_ext}");
		print "Location:admin.$FORM{script_ext}?action=login&username=admin&password=mojoscripts\n\n";
	}
	if($FORM{'step'} eq "final"){
		require "config.pl";
      &Initialization;
      $message = &CheckConfiguration;
		foreach my $key(keys %FORM) {$CONFIG{$key}=$FORM{$key};  }
		&LoadDefaultConfig;
		&FileWrite($CONFIG{group_db}, "admin|11111111111111111\nmoderator|00111111111111111\ndemo|00001010111011110\n");
		$message .= "<li>$mj{setup47}</li>" unless (-e $CONFIG{group_db});
		&PrintInstallation($message) if $message;
		$message =qq|<br>$mj{setup50}<br>|;
		&WriteConfig;
      &Initialization;
      &DbInit;
		&CreateImageFiletype;
      &CreateAdministrator("admin","admin");
	   &CreateAdministrator("demo","demo");
		&CreateDefaultCats;
      &CreateDefaultAccounts;

		&SendInstallNotification;
      &PrintInstallation($message);
	}
	elsif($FORM{step} eq "2"){
		if($FORM{agree}){	&PrintMysqlopt($ENV{SCRIPT_NAME});	}
		else{					print "Location:http://www.mojoscripts.com\n\n";	}
	}
	elsif($FORM{step} eq "3"){
	       $message=&CheckMysqlInput;
	       if ($message) { &PrintMysqlopt($ENV{SCRIPT_NAME},$message);}
          $CONFIG{mysql_hostname}=$FORM{mysql_hostname};
          $CONFIG{mysql_database}=$FORM{mysql_database};
 	       $CONFIG{mysql_username}=$FORM{mysql_username};
          $CONFIG{mysql_password}=$FORM{mysql_password};
	       &WriteConfig;
	       require "config.pl";
	       &Initialization;
          &PrintInstallation;
        }
	else{								&PrintLicenseAgreement;	}
}
################################################################
sub CheckMysqlInput{
	my($message,$dsn,$dbh);
    $dsn="DBI:mysql:$FORM{mysql_database}:$FORM{mysql_hostname}";
    $dbh=DBI->connect($dsn,$FORM{mysql_username},$FORM{mysql_password});
    if (!$dbh) {
         $message="ERROR: Unable to connect user \'$FORM{mysql_username}\' to base \'$FORM{mysql_database}\' on host
         \'$FORM{mysql_hostname}\'. Please check MySQL options.";
    }
    return $message;
}
###############################################################
sub CreateImageFiletype{
	my(%DB);
   $DB{media_size}=qq|50000|;
   $DB{ext}= q|jpg, jpeg, gif, png|;
	$DB{type_name}='Images';
	$DB{window}='samewindow';
	$DB{code}=qq|<table>
                 <tr><td align=center><a href="javascript:window.history.back()"><img src="[FILENAME]" border="0"></a></td></tr>
                 <tr><td align=center>[TITLE]</td></tr>
                </table>|;
	$DB{thumbcode}=qq|<table>
                      <tr><td align=center><a href="[FILEVIEW_URL]"><img src="[THUMBNAIL]" border="0"></a></td></tr>
                      <tr><td align=center>Click to view fullsize</td></tr>
                     </table>|;
	&AddDB(\%DB,'filetype');
}
###############################################################
sub CreateAdministrator{
	my(%DB);
	($DB{username}, $DB{position}) = @_;
	$DB{password}='mojoscripts';
	&AddDB(\%DB,'admin');
}
##################################################################################
sub CreateDefaultCats{
	my($cat,$cat1,@def_cats_a,@def_cats_b,@def_cats_c,%DEF_SUBS,%CAT,%CAT1);
	@def_cats_a=("Employment","Real Estate","Computers & Software","Education","Vacation & Travel",
	 "Autos","Personals","Pets","Health","Merchandise","Entertainment","Miscellaneous");
   @def_cats_b =("For Sale","For Rent","Wanted","Offered","Announcements","Other");
	@def_cats_c =("New England","The Middle Atlantic","The South","The Midwest","The Southwest","The West","Outside USA");
	$DEF_SUBS{"New England"}=["Connecticut","Maine","Massachusetts","New Hampshire","Rhode Island","Vermont"];
	$DEF_SUBS{"The Middle Atlantic"}=["Delaware","Maryland","New York","New Jersey","Pennsylvania","Washington D.C."];
	$DEF_SUBS{"The South"}=["Alabama","Arkansas","Florida","Georgia","Kentucky","Louisiana","Mississippi","North Carolina","South Carolina","Tennessee","Virginia","West Virginia"];
	$DEF_SUBS{"The Midwest"}=["Illinois","Indiana","Iowa","Kansas","Michigan","Minnesota","Missouri","Nebraska","North Dakota","Ohio","South Dakota","Wisconsin"];
	$DEF_SUBS{"The Southwest"}=["Arizona","New Mexico","Oklahoma","Texas"];
	$DEF_SUBS{"The West"}=["Alaska","Colorado","California","Hawaii","Idaho","Montana","Nevada","Oregon","Utah","Washington","Wyoming"];

	$CAT1{cattype}='a';
   foreach $cat(@def_cats_a){
	     $CAT{cattype}='a';
        $CAT{name}=$cat;
		  $CAT{subs}=@{$DEF_SUBS{$cat}};
        %CAT=&AddCategoryDB(\%CAT);

		  $CAT1{parent}=$CAT{id};
		  foreach $cat1(@{$DEF_SUBS{$cat}}){
			  $CAT1{name}=$cat1;
			  &AddCategoryDB(\%CAT1);
		  }
		  undef %CAT;
	}

	$CAT1{cattype}='b';
   foreach $cat(@def_cats_b){
        $CAT{cattype}='b';
        $CAT{name}=$cat;
		  $CAT{subs}=@{$DEF_SUBS{$cat}};
        %CAT=&AddCategoryDB(\%CAT);

		  $CAT1{parent}=$CAT{id};
		  foreach $cat1(@{$DEF_SUBS{$cat}}){
			  $CAT1{name}=$cat1;
			  &AddCategoryDB(\%CAT1);
		  }
		  undef %CAT;
	}


	$CAT1{cattype}='c';
   foreach $cat(@def_cats_c){
	     $CAT{cattype}='c';
        $CAT{name}=$cat;
		  $CAT{subs}=@{$DEF_SUBS{$cat}};
        %CAT=&AddCategoryDB(\%CAT);

		  $CAT1{parent}=$CAT{id};
		  foreach $cat1(@{$DEF_SUBS{$cat}}){
			  $CAT1{name}=$cat1;
			  &AddCategoryDB(\%CAT1);
		  }
		  undef %CAT;
	}
}
##############################################################################
sub CreateDefaultAccounts{
        my (%DB);

	unless (-d $CONFIG{account_path}){
		mkpath($CONFIG{account_path}, 0, 0777);
		chmod(0777, $CONFIG{account_path});
	}

        $DB{date_create}=time;
        $DB{date_end}='';
        $DB{ID}='guest';
        $DB{name}='Guest account (default account for non-registered visitors)';
        $DB{description}='Guest account (default account for non-registered visitors)';
        $DB{setup_finished}=qq|powered by mojoscripts.com|;
        $DB{trial_amount}='00.00';
        $DB{trial_period}='unlimited';
        $DB{trial_time}="D";
        $DB{trial_length}=2**32-2;
        $DB{recurring_amount}='00.00';
        $DB{recurring_period}="unlimited";
        $DB{recurring_time}="D";
        $DB{recurring_length}=2**32-2;
        $DB{email}='';
        $DB{gateway}='';
        $DB{hide}='checked';

        $DB{ad_browse}='checked';
        $DB{ad_search}='checked';
        $DB{ad_search_advanced}='checked';
        $DB{ad_view}='checked';
        $DB{cupid_search}='';
        $DB{member_view}='checked';
        unless(-d "$CONFIG{account_path}/guest"){
            mkdir("$CONFIG{account_path}/guest", 0777);
            chmod(0777, "$CONFIG{account_path}/guest");
        }

        &AddAccountDB(\%DB);
#Default
	$DB{ID}='member';
        $DB{name}='Member account';
        $DB{description}='Member account';
        $DB{setup_finished}=qq|powered by mojoscripts.com|;
        $DB{trial_amount}='00.00';
        $DB{trial_period}='unlimited';
        $DB{trial_time}="D";
        $DB{trial_length}=2**32-2;
        $DB{recurring_amount}='00.00';
        $DB{recurring_period}="unlimited";
        $DB{recurring_time}="D";
        $DB{recurring_length}=2**32-2;
        $DB{email}='';
        $DB{gateway}='';
        $DB{hide}='';
	require "$CONFIG{program_files_path}/membership.txt";

	foreach $perm(@perms) {$DB{$perm}='checked' unless (&ArrayIndex(\@text_perms, $perm) != -1);}
	$DB{ad_allowed}='5';
	$DB{media_allowed}='5';
	$DB{ss_allowed}='5';
	$DB{mailbox_allowed}='100';
	$DB{gallery_allowed}='500000';
	$DB{ad_length}='45';
        $DB{P_number_of_pm_sent_per_month}='20';
        $DB{P_number_of_ads_saved_to_hotlist}='5';        
        $DB{P_ability_to_edit_posted_ads}='CHECKED';        
        $DB{P_min_ad_title_length}='5';        
        $DB{P_max_ad_title_length}='200';

        $DB{P_min_description_title_length}='5';
        $DB{P_max_description_title_length}='700';
        
        	
        unless(-d "$CONFIG{account_path}/member"){
            mkdir("$CONFIG{account_path}/member", 0777);
            chmod(0777, "$CONFIG{account_path}/member");
        }
	&AddAccountDB(\%DB);
}
################################################################
sub SendInstallNotification{
	my $email = "install\@mojoscripts.com";
	my $msg=&SendMail($CONFIG{myname}, $CONFIG{myemail}, $email, "Installing: $mj{program} $mj{version}", "Test email sent by install.cgi from domain $ENV{'HTTP_HOST'} (server admin $ENV{SERVER_ADMIN}) located at $ENV{'SCRIPT_FILENAME'} by $ENV{REMOTE_ADDR} at ".localtime(&TimeNow));
}
###############################################################
sub WriteConfig{
	my($filename);
	if($ENV{PATH_TRANSLATED}){
		($filename = $ENV{PATH_TRANSLATED}) =~ s/\\/\//g;
		$filename=~s/(\/)?install\.(cgi|pl)$//;
#		$filename  = &ParentDirectory($filename);
		$filename .=  "/config.pl";
	}
	else{
		$filename  = $ENV{SCRIPT_FILENAME};
		$filename  = &ParentDirectory($filename);
		$filename .= "/config.pl";
	}
	open(FILE, ">$filename") or &PrintFatal("$mj{file3}: \"$filename\"", (caller)[1], (caller)[2]);
#	flock(FILE,2);
	print FILE qq~
\$CONFIG{site_title}=    qq|$FORM{site_title}|;
\$CONFIG{document_root}= qq|$FORM{document_root}|;
\$CONFIG{backup_path}=   qq|$FORM{backup_path}|;
\$CONFIG{email_path}=    qq|$FORM{email_path}|;
\$CONFIG{image_path}=    qq|$FORM{image_path}|;
\$CONFIG{image_url}=     qq|$FORM{image_url}|;
\$CONFIG{log_path}=      qq|$FORM{log_path}|;
\$CONFIG{photo_path}=    qq|$FORM{photo_path}|;
\$CONFIG{photo_url}=     qq|$FORM{photo_url}|;
\$CONFIG{program_files_path}=qq|$FORM{program_files_path}|;
\$CONFIG{script_path}=   qq|$FORM{script_path}|;
\$CONFIG{script_url}=    qq|$FORM{script_url}|;
\$CONFIG{session_path}=  qq|$FORM{session_path}|;
\$CONFIG{template_path}= qq|$FORM{template_path}|;
\$CONFIG{var_path}=      qq|$FORM{var_path}|;
\$CONFIG{mysql_hostname}=qq|$CONFIG{mysql_hostname}|;
\$CONFIG{mysql_database}=      qq|$CONFIG{mysql_database}|;
\$CONFIG{mysql_username}=    qq|$CONFIG{mysql_username}|;
\$CONFIG{mysql_password}=    qq|$CONFIG{mysql_password}|;
\$CONFIG{myname}=        qq|$FORM{myname}|;
\$CONFIG{myemail}=       q|$FORM{myemail}|;
\$CONFIG{sendmail}=      qq|$FORM{sendmail}|;
\$CONFIG{smtp_server}=   qq|$FORM{smtp_server}|;
\$CONFIG{system}=        qq|$FORM{system}|;
\$CONFIG{language_lib}=  qq|$FORM{language_lib}|;
\$CONFIG{script_ext}=    qq|$FORM{script_ext}|;
~;

my $config_footer =<<'_END_OF_FILE_';
######### Configurations ##########
$CONFIG{lsh}=            qq|1|;
$CONFIG{lex}=            qq|2|;
$CONFIG{lun}=            qq|8|;
$CONFIG{flock}=          qq||;
$CONFIG{rename}=         qq|1|;
$CONFIG{javascript}=     qq|1|;
$CONFIG{mpp}=            qq|40|;
$CONFIG{lpp}=            qq|25|;
$CONFIG{daysnew}=        qq|10|;

#$CONFIG{ad_length}=      qq|45|;
$CONFIG{ad_type}=        qq|instant|;
$CONFIG{ad_email}=       q|webmaster@mojoscripts.com|;
$CONFIG{ads_when_expires}=qq|delete|;
$CONFIG{ads_when_conforms}=qq|0|;
$CONFIG{ss_number}=qq|10|;

$CONFIG{gal_file_type}=  qq|instant|;
$CONFIG{media_width}=    qq|75|;
$CONFIG{media_height}=   qq|100|;

$CONFIG{member_type}=    qq|instant|;
$CONFIG{member_notify}=   q|webmaster@mojoscripts.com|;
$CONFIG{member_length}=  qq|30|;
$CONFIG{member_length_login}=qq||;
$CONFIG{member_length_adpost}=  qq||;
$CONFIG{advanced_expire_email}=qq||;
$CONFIG{duplicate_email}=qq|1|;
#$CONFIG{mailbox_size}=   qq|100|;
$CONFIG{username_length}=qq|5|;
$CONFIG{password_length}=qq|5|;

$CONFIG{max_wordlength}= qq|25|;
$CONFIG{max_description}=qq|700|;
$CONFIG{min_description}=qq|20|;
$CONFIG{short_description}=qq|200|;
$CONFIG{allow_html}=qq|0|;
$CONFIG{bad_words}=qq||;
$CONFIG{mail_line_length}=qq|55|;

$CONFIG{thumbnailer}=    qq|0|;
$CONFIG{photos_first}=   qq|0|;
$CONFIG{hide_blank}=     qq|0|;
$CONFIG{adpost_pages}=   qq|2|;
$CONFIG{show_empty_subs}=qq|1|;
$CONFIG{paysite}=        qq|1|;

$CONFIG{catlayout}=      qq|2|;

$CONFIG{default_account}=qq|member|;
$CONFIG{mail_non_members}= qq|1|;
$CONFIG{max_message_length}= qq|3000|;
$CONFIG{convert_links_to_friendly}= qq|0|;
$CONFIG{days_keep_ads_in_db_after_expire}=qq|10|;
$CONFIG{datetime_algorithm}=qq|POSIX|;
$CONFIG{datetime_format}=qq|%A, %B %d, %Y|;
$CONFIG{change_ad_used_after_delete_ad}=qq|1|;
$CONFIG{add_new_account_ads_allowed_to_previous_ads_allowed}=qq|0|;
$CONFIG{increase_member_ads_used_during_renewing_ad}=qq|0|;
$CONFIG{currency}='$';
$CONFIG{mod_perl}= qq|0|;

$CONFIG{check_wholename}=qq|0|;
$CONFIG{check_case}=     qq|0|;

$CONFIG{charset}= qq|ISO-8859-1|;
################ TABLE DEFINITION  ########################
$TABLE{cat_cols_a}=qq|2|;
$TABLE{cat_cols_b}=qq|1|;
$TABLE{cat_cols_c}=qq|1|;

$TABLE{cat_table_a}=qq|width="100%" border="0" cellspacing="0" cellpadding="0"|;
$TABLE{cat_table_b}=qq|width="100%" border="0" cellspacing="0" cellpadding="0"|;
$TABLE{cat_table_c}=qq|width="100%" border="0"  cellspacing="0" cellpadding="0"|;

$TABLE{cat_tr_a}=qq||;
$TABLE{cat_tr_b}=qq||;
$TABLE{cat_tr_c}=qq||;

$TABLE{cat_td_a}=qq||;
$TABLE{cat_td_b}=qq||;
$TABLE{cat_td_c}=qq||;

#$TABLE{menu_table}           =qq||;
#$TABLE{menu_tr}              =qq||;
#$TABLE{menu_td}              =qq||;

$TABLE{media_table}          =qq|width="100%" border="0"|;
$TABLE{media_tr}             =qq||;
$TABLE{media_td}             =qq||;
$TABLE{media_cols}           =qq|5|;

$TABLE{account_table}        =qq|width="100%" border="1" cellspacing="0" cellpadding="2" bordercolor="#EBEBEB"|;
$TABLE{account_tr_header}    =qq|align="center"|;
$TABLE{account_tr_footer}    =qq|align="center"|;
$TABLE{account_tr}           =qq||;
$TABLE{account_td_accname}   =qq||;
$TABLE{account_td_key}       =qq||;
$TABLE{account_td_value}     =qq|bgcolor="#CCCCCC" align="center"|;
$TABLE{account_order_label}   =qq|Order|;
$TABLE{account_supported_label}       =qq|<b>Yes!</b>|;
$TABLE{account_permissions_label}     =qq|Permissions|;
######################## ADVANCED SETTINGS  ##########################
#saved search defaults
$CONFIG{ss_turned_on}=qq|1|;
$CONFIG{ss_frequency}=qq|1|;
$CONFIG{ad_intervals}=qq|price|;
$CONFIG{member_intervals}=qq||;

################ DEBUG LOG options ################ 
$CONFIG{debug_send_mail}=qq|1|;
$CONFIG{debug_member_status_change}=qq|1|;
$CONFIG{debug_payment_notification}=qq|1|;
$CONFIG{debug_ad_status_change}=qq|1|;

################################################################
1;
_END_OF_FILE_
	print FILE $config_footer;
#	flock(FILE,8);
	close(FILE);
	chmod(0777, $filename);
	return 1;
}

################################################################################
sub PrintMysqlopt{
	my ($url, $message);
	($url,$message) = @_;
	print "Content-Type:text/html\n\n";
	print qq|
<HTML>
<HEAD>
<TITLE>$mj{program}</TITLE>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html; charset=iso-8859-1">
</HEAD>
<BODY bgcolor="#FFFFFF">
<form name="mojoScripts" method="post" action="$url">
  <input type="hidden" name="type" value="config">
	<input type="hidden" name="class" value="config">
  	<input type="hidden" name="step" value="3">
  <table  cellpadding="5" cellspacing="0" width="100%" border="1" bordercolor="#EEEEEE">
    <tr> 
      <td valign="middle" align="center" height="42" colspan="2"> <b><font color="#0000FF" face="Verdana" size="5">$mj{program}</font><font color="#FF0000" face="Verdana" size="5"> 
        $mj{version}<br>
        </font><font color="#CCCCCC" face="Verdana" size="5"><font size="2" color="#CCCCCC">by 
        <a href="http://www.mojoscripts.com"><font size="2" color="#FF00FF">mojoscripts</font></a><br>
        <font color="#000000">$mj{title}</font></font></font></b></td>
    </tr>
    <tr> 
      <td valign="middle" align="center" height="32" colspan="2"><font color=red><b>$message</b></font></td>
    </tr>
    <tr> 
      <td  valign="middle" align="center" colspan="2"> 
        <b><font face="Tahoma" size="2">$mj{setup51}</font></b>
      </td>
    </tr>
    <tr> 
      <td width="164" valign="top" align="center"> 
        <div align="left"><b><font face="Tahoma" size="2">$mj{setup52}</font></b></div>
      </td>
      <td valign="top" align="center" width="797">
          <div align="left"><!-- <font face="Tahoma" size="2">$mj{setup53}<br> -->
          <input type="text" name="mysql_hostname" size="30" value="$FORM{mysql_hostname}">
          </font></div>
      </td>
    </tr>
    <tr> 
      <td width="164" valign="top" align="center"> 
        <div align="left"><b><font face="Tahoma" size="2">$mj{setup54}</font></b></div>
      </td>
      <td valign="top" align="center" width="797">
          <div align="left"><input type="text" name="mysql_username" size="30" value="$FORM{mysql_username}">
          </font></div>
      </td>
    </tr>
    <tr> 
      <td width="164" valign="top" align="center"> 
        <div align="left"><b><font face="Tahoma" size="2">$mj{setup55}</font></b></div>
      </td>
      <td valign="top" align="center" width="797">
          <div align="left"><input type="text" name="mysql_password" size="30" value="$FORM{mysql_password}">
          </font></div>
      </td>
    </tr>
    <tr> 
      <td width="164" valign="top" align="center"> 
        <div align="left"><b><font face="Tahoma" size="2">$mj{setup56}</font></b></div>
      </td>
      <td valign="top" align="center" width="797">
          <div align="left"><input type="text" name="mysql_database" size="30" value="$FORM{mysql_database}">
          </font></div>
      </td>
    </tr>
	<tr> 

	<tr> 
	  <td valign="middle" align="center" colspan="2"> 
        <input type="SUBMIT" value=" $TXT{save}" name="submit">
        <input type="reset" name="reset" value=" $TXT{reset}">
      </td>
    </tr>
  </table>
</form>
</BODY>
</HTML>
	|;
	&PrintFooter;
}










############################################################
sub PrintInstallation{
	&PrintHeader;
	my($error,$host, $message, $root_path, $this_url, $this_dir);
	$error = shift;
	if($ENV{PATH_TRANSLATED}){
		$message = qq|Our software detects that you are running Windows. You MUST substitute all instances of backslashes "\\" with forward slashes "/" in your paths. Failure to do so may result in Internal Server Errors. You may skip anything related to "File Permissions".|;
		$root_path = $ENV{PATH_TRANSLATED};
		$root_path =~ s/\\/\//g;
		$this_dir = &ParentDirectory($root_path);
		$root_path =~ s/$ENV{SCRIPT_NAME}//i;

		$this_url = $ENV{'HTTP_HOST'}. &ParentDirectory($ENV{'SCRIPT_NAME'});
	}
	else{
		$message = qq|<font size=5 color=red>$mj{setup7}</font>| unless (-w "config.pl");
		$root_path = $ENV{SCRIPT_FILENAME};
		$root_path =~ s/$ENV{SCRIPT_NAME}//i;

		$this_dir = &ParentDirectory($ENV{'SCRIPT_FILENAME'});
		$this_url = $ENV{'HTTP_HOST'}. &ParentDirectory($ENV{'SCRIPT_NAME'});
	}

	$FORM{site_title}=   qq|$mj{title}|                      unless $FORM{site_title};
	$FORM{root_path}=    qq|$root_path|                      unless $FORM{root_path};
	$FORM{document_root}=qq|$root_path| 				         unless $FORM{document_root};
	$FORM{program_files_path}="$this_dir/program_files" 		unless $FORM{program_files};
#	$FORM{data_path}=    qq|$FORM{program_files}/data|      	unless $FORM{data_path};
	$FORM{email_path}=   qq|$this_dir/emails|           	  	unless $FORM{email_path};
	$FORM{image_path}=   qq|$this_dir/images|             	unless $FORM{image_path};
#	$FORM{member_path}=  qq|$this_dir/members|            	unless $FORM{member_path};
#	$FORM{mail_path}=    qq|$FORM{program_files}/mails|    	unless $FORM{mail_path};
	$FORM{photo_path}=   qq|$this_dir/photos|             	unless $FORM{photo_path};
	$FORM{template_path}=qq|$this_dir/templates|          	unless $FORM{template_path};
	$FORM{session_path}= qq|$FORM{program_files}/sessions| 	unless $FORM{session_path};
	$FORM{script_path}=  qq|$this_dir|                       unless $FORM{script_path};
	$FORM{mysql_hostname}=qq|localhost| unless $FORM{mysql_hostname};
   $FORM{homelink}=     qq|http://$ENV{HTTP_HOST}|    		unless $FORM{homelink};
	$FORM{myemail}=      qq|$ENV{SERVER_ADMIN}|            	unless $FORM{myemail};
	my @myname= split(/\@/, $FORM{myemail});
	$FORM{'myname'} =    $myname[0]            			  		unless $FORM{myname};
	$FORM{'sendmail'} =  &MailProgram                    		unless $FORM{sendmail};

#	$FORM{smtp} = qq|mail.$host|                        unless $FORM{smtp};
#	$HTML_language = &BuildLanguageMenu;
	print qq|
   <HTML>
   <HEAD>
   <TITLE>$mj{program}</TITLE>
   </HEAD>
   <BODY bgcolor="#FFFFFF">
	|;
	$TEMPLATE{config}="$this_dir/templates/config.html";
	&ConfigTemplate($ENV{SCRIPT_NAME}, $error?$error:$message);
	print qq|</BODY></HTML>|;
exit;
}
############################################################
sub PrintLicenseAgreement{
	my($license, $request, $response, $ua);
	if(&isModInstalled("LWP")){
		require LWP::UserAgent;
 		my $ua = LWP::UserAgent->new;
 		my $request = HTTP::Request->new('POST', 'http://www.mojoscripts.com/cgi-bin/license/agreement.cgi');
 		$request->content_type('application/x-www-form-urlencoded');
		$request->content("type=retail");
		my $response = $ua->request($request);
		$license = $response->content;
	}
	unless($license){
		$license =qq|
		1. License
This is not a freeware!!! It has to be paid to use.
Anyone found to be using an unlicensed version of this software will
be faced with legal action. This software is only distributed from
http://www.mojoscripts.com/. If you have purchased this script from
somewhere other than http://www.mojoscripts.com/ then please email
sales\@mojoscripts.com immediately.

This software may be modified free of charge as long as this copyright
notice and the comments above remain intact. Selling or distributing
the code of this software or a software derived from this software,
without our prior written consent is expressly forbidden.

2. Indemnification
Customer agrees that it shall defend, indemnify, save and hold
mojoscripts.com and any persons affiliated with mojoscripts.com,
harmless from any and all demands, liabilities, losses, costs and claims,
including reasonable attorney's fees asserted against mojoScripts.com,
its agents, its customers, officers and employees, that may arise or result
from any service provided or performed or agreed to be performed or any product
sold by customer, its agents, employees or assigns. Customer agrees to defend,
indemnify and hold harmless mojoScripts.com, its agents, its cusomters, officers,
and employees, against liabilities arising out of:
(a) any injury to person or property caused by a products sold or  otherwise
 distributed in connection with mojoScripts.com products;
(b) any material supplied by customer infringing or allegedly infringing on the
proprietary rights of a third party;
(c) copyright infringement and
(d) any defective products sold to customer from mojoScripts.com
		|;
		$license = qq|<pre><br>$license</pre>|;
	}

#	print "Content-Type:text/html\n\n";
	&PrintHeader;
	print qq|
<html>
<head>
<title>End User License Agreement</title>
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
</head>

<body bgcolor="#FFFFFF" text="#000000" background="#EBEBEB">
<table width=600 cellpadding=2 cellspacing=0 border=0 align="center" bgcolor=#FFFFFF>
  <tr>
    <td height="190" valign="top"><font face="Arial" size="2"><b>Terms of Use</b>
      <p>
<b>Before installing and using $mj{program} $mj{version}, you must agree to the terms below. If you do not agree, please stop using  this software and delete it from your server.</b>
      $license
         For complete <a href="http://www.mojoscripts.com/order/eula.html">term of use</a>, please visit our website.
      <p>&nbsp;
      </font></td>
  </tr>
  <tr>
    <td align=center height="43">
      <form name="mojo" method="post" action="$ENV{SCRIPT_NAME}">
        <input type="hidden" name="step" value="2">
        <input type="submit" name="agree" value="I fully understand and agree to the above!">
        <br>
        <input type="submit" name="disagree" value="I do not agree, take me somewhere else! ">
      </form>
      <font face="Arial" size="2">
      <p>
      </font></td>
  </tr>
</table>
</body>
</html>

	|;
	&PrintFooter;
}
############################################################
1;
